# PrecompileTools

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaLang.github.io/PrecompileTools.jl/stable/)
[![Build Status](https://github.com/JuliaLang/PrecompileTools.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/JuliaLang/PrecompileTools.jl/actions/workflows/CI.yml?query=branch%3Amain)
[![Coverage](https://codecov.io/gh/JuliaLang/PrecompileTools.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/JuliaLang/PrecompileTools.jl)

PrecompileTools allows you to reduce the latency of the first execution of Julia code.
**It is applicable for package developers and for "ordinary users" in their personal workflows.**

To learn how to use PrecompileTools, see the [documentation](https://JuliaLang.github.io/PrecompileTools.jl/stable/).

## PrecompileTools and PackageCompiler

Particularly on Julia 1.9 and higher, PrecompileTools allows dramatic reduction in "time to first execution" (TTFX) without the need for user-customization.
In this respect, it shares goals with (and performs similarly to) [PackageCompiler](https://github.com/JuliaLang/PackageCompiler.jl).

Nevertheless, the two are not identical:

- only PrecompileTools can be used by *package developers* to ensure a better out-of-box experience for your users
- only PrecompileTools allows you to update your packages without needing to rebuild Julia
- only PackageCompiler dramatically speeds up loading time (i.e., `using ...`) for all the packages

Here is a table summarizing the information.

| Task | Julia 1.9 + PrecompileTools | PackageCompiler |
|:----- | ---:| ---:|
| Developers can reduce out-of-box TTFX for their users | ✔️ | ❌ |
| Users can reduce TTFX for custom tasks | ✔️ | ✔️ |
| Packages can be updated without rebuilding system image | ✔️ | ❌ |
| Reduces time to load (TTL) | ❌ | ✔️ |

The difference in time to load arises because the system image can safely skip all the code-validation checks that are necessary when loading packages. Examples of the reduction in time to first execution and time to load can be found in the [Julia 1.9 highlights blog post](https://julialang.org/blog/2023/04/julia-1.9-highlights/#caching_of_native_code).

## Inspecting the package precompile files 

[PkgCacheInspector](https://github.com/timholy/PkgCacheInspector.jl) provides insight about what's stored in Julia's package precompile files.

## History (origins as SnoopPrecompile)

PrecompileTools is the successor to [SnoopPrecompile](https://github.com/timholy/SnoopCompile.jl/tree/master/SnoopPrecompile).
PrecompileTools differs in naming and in how one disables precompilation, but is otherwise a drop-in replacement.

This new package was created for several reasons:

- PrecompileTools has become (directly or indirectly) a dependency of much of the Julia ecosystem, a trend that seems likely to grow with time.
    Therefore, this package is now hosted in the JuliaLang GitHub organization.
- As Julia's own stdlibs migrate to become independently updateable (true for DelimitedFiles in Julia 1.9, with others anticipated for Julia 1.10), several of them would like to use PrecompileTools for high-quality precompilation. That requires making PrecompileTools its own "upgradable stdlib."
- This package introduces the [use of Preferences](https://github.com/timholy/SnoopCompile.jl/issues/356) to make packages more independent of one another. Since this would have been a breaking change, it seemed like a good opportunity to fix other issues, too.

For more information and discussion, see the [Discourse announcement post](https://discourse.julialang.org/t/ann-snoopprecompile-precompiletools/97882).

module PC_A

using PrecompileTools: @setup_workload, @compile_workload

struct MyType
    x::Int
end

inferencebarrier(@nospecialize(arg)) = Base.inferencebarrier(arg)

function call_findfirst(x, list)
    # call a method defined in Base by runtime dispatch
    return findfirst(==(inferencebarrier(x)), inferencebarrier(list))
end

@setup_workload begin
    list = [MyType(1), MyType(2), MyType(3)]
    @compile_workload begin
        call_findfirst(MyType(2), list)
    end
end

end # module PC_A

module AliasTables

using Random
using PrecompileTools

export AliasTable

struct AliasTable{T}
    x::T
end
Base.rand(x::AliasTable) = rand(x.x)

PrecompileTools.@compile_workload begin
    at = AliasTable([1.0, 2.0])
    rand(at)
end

end

"""
    @recompile_invalidations begin
        using PkgA
        ⋮
    end

Recompile any invalidations that occur within the given expression. This is generally intended to be used
by users in creating "Startup" packages to ensure that the code compiled by package authors is not invalidated.
"""
macro recompile_invalidations(expr)
    # use QuoteNode instead of esc(Expr(:quote)) so that $ is not permitted as usual (instead of having this macro work like `@eval`)
    return :(recompile_invalidations($__module__, $(QuoteNode(expr))))
end

const ReinferUtils = isdefined(Base, :ReinferUtils) ? Base.ReinferUtils : Base.StaticData

function recompile_invalidations(__module__::Module, @nospecialize expr)
    listi = ccall(:jl_debug_method_invalidation, Any, (Cint,), 1)
    liste = ReinferUtils.debug_method_invalidation(true)
    try
        Core.eval(__module__, expr)
    finally
        ccall(:jl_debug_method_invalidation, Any, (Cint,), 0)
        ReinferUtils.debug_method_invalidation(false)
    end
    if ccall(:jl_generating_output, Cint, ()) == 1
        foreach(precompile_mi, invalidation_leaves(listi, liste))
    end
    nothing
end

function invalidation_leaves(listi, liste)
    umis = Set{Core.MethodInstance}()
    # `queued` is a queue of length 0 or 1 of invalidated MethodInstances.
    # We wait to read the `depth` to find out if it's a leaf.
    queued, depth = nothing, 0
    function cachequeued(item, nextdepth)
        if queued !== nothing && nextdepth <= depth
            push!(umis, queued)
        end
        queued, depth = item, nextdepth
    end

    # Process method insertion/deletion events
    i, ilast = firstindex(listi), lastindex(listi)
    while i <= ilast
        item = listi[i]
        if isa(item, Core.MethodInstance)
            if i < lastindex(listi)
                nextitem = listi[i+1]
                if nextitem == "invalidate_mt_cache"
                    cachequeued(nothing, 0)
                    i += 2
                    continue
                end
                if nextitem ∈ ("jl_method_table_disable", "jl_method_table_insert")
                    cachequeued(nothing, 0)
                    push!(umis, item)
                end
                if isa(nextitem, Integer)
                    cachequeued(item, nextitem)
                    i += 2
                    continue
                end
            end
        end
        if (isa(item, Method) || isa(item, Type)) && queued !== nothing
            push!(umis, queued)
            queued, depth = nothing, 0
        end
        i += 1
    end

    # Process edge-validation events
    i, ilast = firstindex(liste), lastindex(liste)
    while i <= ilast
        tag = liste[i + 1]   # the tag is always second
        if tag == "method_globalref"
            push!(umis, Core.Compiler.get_ci_mi(liste[i + 2]))
            i += 4
        elseif tag == "insert_backedges_callee"
            push!(umis, Core.Compiler.get_ci_mi(liste[i + 2]))
            i += 4
        elseif tag == "verify_methods"
            push!(umis, Core.Compiler.get_ci_mi(liste[i]))
            i += 3
        else
            error("Unknown tag found in invalidation list: ", tag)
        end
    end

    return umis
end

module MSort

# issue #26

using PrecompileTools

function quicksort(
    v::Vector{T};
    lo::Int = 1,
    hi::Int = length(v),
) where {T <: Union{Int64, Float64}}
    x = copy(v)
    quick!(x, lo, hi)
    x
end

function partition(
    xp::Vector{T},
    pivot::T,
    left::Int,
    right::Int,
) where {T <: Union{Int64, Float64}}
    while left <= right
        while xp[left] < pivot
            left += 1
        end
        while pivot < xp[right]
            right -= 1
        end
        if left <= right
            xp[left], xp[right] = xp[right], xp[left]
            left += 1
            right -= 1
        end
    end
    left, right
end

function quick!(
    xp::Vector{T},
    i::Int,
    j::Int,
) where {T <: Union{Int64, Float64}}
    if j > i
        left, right = partition(xp, xp[(j+i)>>>1], i, j)
        quick!(xp, i, right)
        quick!(xp, left, j)
    end
end

@setup_workload begin
    @compile_workload begin
        quicksort(rand(64))
    end
end

end

using PrecompileTools
using Test
using Pkg
using UUIDs
using Base: specializations

@testset "PrecompileTools.jl" begin
    push!(LOAD_PATH, @__DIR__)

    using PC_A
    # Check that calls inside @setup_workload are not precompiled
    m = which(Tuple{typeof(Base.vect), Vararg{T}} where T)
    have_mytype = false
    for mi in specializations(m)
        mi === nothing && continue
        have_mytype |= Base.unwrap_unionall(mi.specTypes).parameters[2] === PC_A.MyType
    end
    have_mytype && @warn "Code in setup_workload block was precompiled"
    # Check that calls inside @compile_workload are precompiled
    m = only(methods(PC_A.call_findfirst))
    count = 0
    for mi in specializations(m)
        mi === nothing && continue
        sig = Base.unwrap_unionall(mi.specTypes)
        if sig == Tuple{typeof(PC_A.call_findfirst), PC_A.MyType, Vector{PC_A.MyType}}
            count += 1
        end
    end
    @test count == 1
    # Even one that was runtime-dispatched
    m = which(Tuple{typeof(findfirst), Base.Fix2{typeof(==), T}, Vector{T}} where T)
    count = 0
    for mi in specializations(m)
        mi === nothing && continue
        sig = Base.unwrap_unionall(mi.specTypes)
        if sig.parameters[3] == Vector{PC_A.MyType}
            count += 1
        end
    end
    @test count == 1

    pipe = Pipe()
    id = Base.PkgId(UUID("d38b61e7-59a2-4ef9-b4d3-320bdc69b817"), "PC_B")
    redirect_stderr(pipe) do
        @test_throws Exception Base.require(id)
    end
    close(pipe.in)
    str = read(pipe.out, String)
    @test occursin(r"UndefVarError: `?missing_function`? not defined", str)

    using PC_C

    script = """
    using PC_D
    exit(isdefined(PC_D, :workload_ran) === parse(Bool, ARGS[1]) ? 0 : 1)
    """

    projfile = Base.active_project()
    Pkg.activate("PC_D")
    Pkg.instantiate()
    using PC_D

    PrecompileTools.Preferences.set_preferences!(PC_D, "precompile_workload" => false)
    @test success(run(`$(Base.julia_cmd()) --project=$(joinpath(@__DIR__, "PC_D")) -e $script 0`))

    PrecompileTools.Preferences.delete_preferences!(PC_D, "precompile_workload"; force = true)
    @test success(run(`$(Base.julia_cmd()) --project=$(joinpath(@__DIR__, "PC_D")) -e $script 1`))
    Pkg.activate(projfile)

    preffile = joinpath(@__DIR__, "PC_D", "LocalPreferences.toml")
    if isfile(preffile)
        rm(preffile)
    end

    oldval = PrecompileTools.verbose[]
    PrecompileTools.verbose[] = true
    mktemp() do path, io
        redirect_stdout(io) do
            include(joinpath(@__DIR__, "PC_E", "src", "PC_E.jl"))
        end
        close(io)
        str = read(path, String)
        @test occursin("MethodInstance for", str)
        modscope = "PC_E."
        @test occursin("$(modscope)f(::$Int)", str)
        @test occursin("$(modscope)f(::String)", str)
    end
    PrecompileTools.verbose[] = oldval

    using NotToplevel
    # Check that calls inside @setup_workload are not precompiled
    m = NotToplevel.NotPrecompiled.themethod
    have_char = have_float = false
    for mi in specializations(m)
        mi === nothing && continue
        have_char |= mi.specTypes.parameters[2] === Char
        have_float |= mi.specTypes.parameters[2] === Float64
    end
    @test !have_float       # not wrapped inside `@compile_workload`
    @test_broken have_char  # is wrapped

    ## @recompile_invalidations

    # Mimic the format written to `_jl_debug_method_invalidation`
    # As a source of MethodInstances, `getproperty` has lots
    m = which(getproperty, (Any, Symbol))
    mis, cis = Core.MethodInstance[], Core.CodeInstance[]
    for mi in specializations(m)
        length(cis) >= 10 && break
        mi === nothing && continue
        push!(mis, mi)
        isdefined(mi, :cache) && push!(cis, mi.cache)
    end
    # These mimic the format of the logs produced by `jl_debug_method_invalidation` (both variants)
    invs = Any[mis[1], 0, mis[2], 1, Tuple{}, m, "jl_method_table_insert"]
    @test PrecompileTools.invalidation_leaves(invs, []) == Set([mis[2]])
    invs = Any[mis[1], 0, mis[2], 1, mis[3], 1, Tuple{}, m, "jl_method_table_insert"]
    @test PrecompileTools.invalidation_leaves(invs, []) == Set([mis[2], mis[3]])
    invs = Any[mis[1], 0, mis[2], 1, Tuple{}, mis[1], 1, mis[3], "jl_method_table_insert", m, "jl_method_table_insert"]
    @test PrecompileTools.invalidation_leaves(invs, []) == Set(mis[1:3])
    invs = Any[mis[1], 1, mis[2], "jl_method_table_disable", m, "jl_method_table_disable"]
    @test PrecompileTools.invalidation_leaves(invs, []) == Set([mis[1], mis[2]])
    invs = Any[mis[1], 1, mis[2], "jl_method_table_disable", mis[3], "jl_method_table_insert", m]
    @test Set([mis[1], mis[2]]) ⊆ PrecompileTools.invalidation_leaves(invs, [])
    invs = Any[mis[1], 1, mis[2], "jl_method_table_insert", mis[2], "invalidate_mt_cache", m, "jl_method_table_insert"]
    @test PrecompileTools.invalidation_leaves(invs, []) == Set([mis[1], mis[2]])
    invs = Any[m, "method_globalref", cis[1], nothing, Tuple{}, "insert_backedges_callee", cis[2], Any[m], cis[3], "verify_methods", cis[4]]
    @test PrecompileTools.invalidation_leaves([], invs) == Set(Core.Compiler.get_ci_mi.(cis[1:3]))

    # Coverage isn't on during package precompilation, so let's test a few things here
    PrecompileTools.precompile_mi(mis[1])

    # Add a real invalidation & repair test
    cproj = Base.active_project()
    mktempdir() do dir
        push!(LOAD_PATH, dir)
        cd(dir) do
            # Method insertion invalidations
            for ((pkg1, pkg2, pkg3), recompile) in ((("RC_A", "RC_B", "RC_C"), false,),
                                                    (("RC_D", "RC_E", "RC_F"), true))
                Pkg.generate(pkg1)
                open(joinpath(dir, pkg1, "src", pkg1*".jl"), "w") do io
                    println(io, """
                    module $pkg1
                    nbits(::Int8) = 8
                    nbits(::Int16) = 16
                    call_nbits(c) = nbits(only(c))
                    begin
                        Base.Experimental.@force_compile
                        call_nbits(Any[Int8(5)])
                    end
                    end
                    """)
                end
                Pkg.generate(pkg2)
                Pkg.activate(joinpath(dir, pkg2))
                Pkg.develop(PackageSpec(path=joinpath(dir, pkg1)))
                open(joinpath(dir, pkg2, "src", pkg2*".jl"), "w") do io
                    println(io, """
                    module $pkg2
                    using $pkg1
                    $(pkg1).nbits(::Int32) = 32
                    end
                    """)
                end
                # pkg3 is like a "Startup" package that recompiles the invalidations from loading the "code universe"
                Pkg.generate(pkg3)
                Pkg.activate(joinpath(dir, pkg3))
                Pkg.develop(PackageSpec(path=joinpath(dir, pkg2)))
                Pkg.develop(PackageSpec(path=dirname(@__DIR__)))   # depend on PrecompileTools
                open(joinpath(dir, pkg3, "src", pkg3*".jl"), "w") do io
                    if recompile
                        println(io, """
                        module $pkg3
                        using PrecompileTools
                        @recompile_invalidations using $pkg2
                        end
                        """)
                    else
                        println(io, """
                        module $pkg3
                        using PrecompileTools
                        using $pkg2
                        end
                        """)
                    end
                end

                @eval using $(Symbol(pkg3))
                mod3 = Base.@invokelatest getglobal(@__MODULE__, Symbol(pkg3))
                mod2 = Base.@invokelatest getglobal(mod3, Symbol(pkg2))
                mod1 = Base.@invokelatest getglobal(mod2, Symbol(pkg1))
                m = only(methods(mod1.call_nbits))
                mi = first(specializations(m))
                wc = Base.get_world_counter()
                @test recompile ? mi.cache.max_world >= wc : mi.cache.max_world < wc
            end

            # Edge-invalidation
            for ((pkg1, pkg2, pkg3), recompile) in ((("RC_G", "RC_H", "RC_I"), false,),
                                                    (("RC_J", "RC_K", "RC_L"), true))
                Pkg.generate(pkg1)
                open(joinpath(dir, pkg1, "src", pkg1*".jl"), "w") do io
                    println(io, """
                    module $pkg1
                    nbits(::Int8) = 8
                    nbits(::Int16) = 16
                    end
                    """)
                end
                Pkg.generate(pkg2)
                Pkg.activate(joinpath(dir, pkg2))
                Pkg.develop(PackageSpec(path=joinpath(dir, pkg1)))
                open(joinpath(dir, pkg2, "src", pkg2*".jl"), "w") do io
                    println(io, """
                    module $pkg2
                    using $pkg1
                    call_nbits(c) = $pkg1.nbits(only(c))
                    begin
                        Base.Experimental.@force_compile
                        call_nbits(Any[Int8(5)])
                    end
                    end
                    """)
                end
                Pkg.generate(pkg3)
                Pkg.activate(joinpath(dir, pkg3))
                Pkg.develop(PackageSpec(path=joinpath(dir, pkg1)))
                Pkg.develop(PackageSpec(path=joinpath(dir, pkg2)))
                Pkg.develop(PackageSpec(path=dirname(@__DIR__)))   # depend on PrecompileTools
                open(joinpath(dir, pkg3, "src", pkg3*".jl"), "w") do io
                    if recompile
                        println(io, """
                        module $pkg3
                        using PrecompileTools
                        @recompile_invalidations begin
                            using $pkg1
                            $pkg1.nbits(::Int32) = 32  # This will cause an edge invalidation
                            using $pkg2
                        end
                        end
                        """)
                    else
                        println(io, """
                        module $pkg3
                        using PrecompileTools
                        using $pkg1
                        $pkg1.nbits(::Int32) = 32  # This will cause an edge invalidation
                        using $pkg2
                        end
                        """)
                    end
                end

                @eval using $(Symbol(pkg3))
                mod3 = Base.@invokelatest getglobal(@__MODULE__, Symbol(pkg3))
                mod2 = Base.@invokelatest getglobal(mod3, Symbol(pkg2))
                mod1 = Base.@invokelatest getglobal(mod2, Symbol(pkg1))
                m = only(methods(mod2.call_nbits))
                mi = first(specializations(m))
                wc = Base.get_world_counter()
                @test recompile ? mi.cache.max_world >= wc : mi.cache.max_world < wc
            end

        end
        pop!(LOAD_PATH)
    end
    Pkg.activate(cproj)

    pop!(LOAD_PATH)
end

module NotToplevel

using NotPrecompiled
using PrecompileTools: @setup_workload, @compile_workload

hello(who::AbstractString) = "Hello, $who"

NotPrecompiled.call_isa_bool(1.0)

@setup_workload begin
    withenv() do
        @compile_workload begin
            hello("x")
            NotPrecompiled.call_isa_bool('x')
        end
    end
end

end # module NotToplevel

using PrecompileTools
using Documenter

DocMeta.setdocmeta!(PrecompileTools, :DocTestSetup, :(using PrecompileTools); recursive=true)

makedocs(;
    modules=[PrecompileTools],
    authors="Tim Holy <tim.holy@gmail.com>, t-bltg <tf.bltg@gmail.com>, and contributors",
    sitename="PrecompileTools.jl",
    format=Documenter.HTML(;
        repolink="https://github.com/JuliaLang/PrecompileTools.jl/",
        prettyurls=get(ENV, "CI", "false") == "true",
        canonical="https://JuliaLang.github.io/PrecompileTools.jl",
        edit_link="main",
        assets=String[],
    ),
    pages=[
        "Home" => "index.md",
        "Invalidations" => "invalidations.md",
        "How PrecompileTools works" => "explanations.md",
        "Reference" => "reference.md",
    ],
)

deploydocs(;
    repo="github.com/JuliaLang/PrecompileTools.jl",
    push_preview=true,
    devbranch="main",
)

const newly_inferred = Core.CodeInstance[]   # only used to support verbose[]

function workload_enabled(mod::Module)
    enabled || return false
    try
        return load_preference(mod, "precompile_workload", true)::Bool
    catch
        true
    end
end

@noinline is_generating_output() = ccall(:jl_generating_output, Cint, ()) == 1

macro latestworld_if_toplevel()
    Expr(Symbol("latestworld-if-toplevel"))
end

function tag_newly_inferred_enable()
    ccall(:jl_tag_newly_inferred_enable, Cvoid, ())
    if !Base.generating_output()   # for verbose[]
        ccall(:jl_set_newly_inferred, Cvoid, (Any,), newly_inferred)
    end
end
function tag_newly_inferred_disable()
    ccall(:jl_tag_newly_inferred_disable, Cvoid, ())
    if !Base.generating_output()   # for verbose[]
        ccall(:jl_set_newly_inferred, Cvoid, (Any,), nothing)
    end
    if verbose[]
        for ci in newly_inferred
            println(ci.def)
        end
    end
    return nothing
end

"""
    @compile_workload f(args...)

`precompile` (and save in the `compile_workload` file) any method-calls that occur inside the expression. All calls (direct or indirect) inside a
`@compile_workload` block will be cached.

`@compile_workload` has three key features:

1. code inside runs only when the package is being precompiled (i.e., a `*.ji`
   precompile `compile_workload` file is being written)
2. the interpreter is disabled, ensuring your calls will be compiled
3. both direct and indirect callees will be precompiled, even for methods defined in other packages
   and even for runtime-dispatched callees (requires Julia 1.8 and above).

!!! note
    For comprehensive precompilation, ensure the first usage of a given method/argument-type combination
    occurs inside `@compile_workload`.

    In detail: runtime-dispatched callees are captured only when type-inference is executed, and they
    are inferred only on first usage. Inferrable calls that trace back to a method defined in your package,
    and their *inferrable* callees, will be precompiled regardless of "ownership" of the callees
    (Julia 1.8 and higher).

    Consequently, this recommendation matters only for:

        - direct calls to methods defined in Base or other packages OR
        - indirect runtime-dispatched calls to such methods.
"""
macro compile_workload(ex::Expr)
    local iscompiling = :($PrecompileTools.is_generating_output() && $PrecompileTools.workload_enabled(@__MODULE__))
    ex = quote
        begin
            $PrecompileTools.@latestworld_if_toplevel  # block inference from proceeding beyond this point (xref https://github.com/JuliaLang/julia/issues/57957)
            $(esc(ex))
        end
    end
    ex = quote
        $PrecompileTools.tag_newly_inferred_enable()
        try
            $ex
        finally
            $PrecompileTools.tag_newly_inferred_disable()
        end
    end
    return quote
        if $iscompiling || $PrecompileTools.verbose[]
            $ex
        end
    end
end

"""
    @setup_workload begin
        vars = ...
        ⋮
    end

Run the code block only during package precompilation. `@setup_workload` is often used in combination
with [`@compile_workload`](@ref), for example:

    @setup_workload begin
        vars = ...
        @compile_workload begin
            y = f(vars...)
            g(y)
            ⋮
        end
    end

`@setup_workload` does not force compilation (though it may happen anyway) nor intentionally capture
runtime dispatches (though they will be precompiled anyway if the runtime-callee is for a method belonging
to your package).
"""
macro setup_workload(ex::Expr)
    local iscompiling = :((ccall(:jl_generating_output, Cint, ()) == 1 && $PrecompileTools.workload_enabled(@__MODULE__)))
    # Ideally we'd like a `let` around this to prevent namespace pollution, but that seem to
    # trigger inference & codegen in undesirable ways (see #16).
    return quote
        if $iscompiling || $PrecompileTools.verbose[]
            let
                $PrecompileTools.@latestworld_if_toplevel  # block inference from proceeding beyond this point (xref https://github.com/JuliaLang/julia/issues/57957)
                $(esc(ex))
            end
        end
    end
end

module PC_E

f(::Int) = 1
f(::String) = 2
f(::Dict) = 3
f(::Real) = 4
f(::Any) = 5

g(list) = [f(x) for x in list]

using PrecompileTools

@setup_workload begin
    list = Any[1, "hi"]
    @compile_workload begin
        for item in list
            f(item)
        end
    end
end

end # module PC_E

module NotPrecompiled

# This module can be a dependency of others to check
# caching: call `call_isa_bool(x::T)` for some `T` and
# then check for `isa_bool(::T)` specializations.

isa_bool(x) = isa(x, Bool)
call_isa_bool(x) = isa_bool(Base.inferencebarrier(x))

const themethod = only(methods(isa_bool))

end # module NotPrecompiled

using PrecompileTools
using Test
using InteractiveUtils

@testset "No-coverage tests" begin
    @assert Base.JLOptions().code_coverage == 0 "These tests should be run with coverage disabled"

    push!(LOAD_PATH, @__DIR__)

    using MSort
    using AliasTables
    x = rand(64)
    pipe = Pipe()
    oldstderr = stderr
    redirect_stderr(pipe)
    @trace_compile begin
        @eval begin
            MSort.quicksort($x)
            at = AliasTable([1.0, 2.0])
            rand(at)
        end
    end
    close(pipe.in)
    redirect_stderr(oldstderr)
    str = read(pipe.out, String)
    @test isempty(str)

    pop!(LOAD_PATH)
end

module PrecompileTools

using Preferences

export @setup_workload, @compile_workload, @recompile_invalidations

const verbose = Ref(false)    # if true, prints all the precompiles
const enabled = @load_preference("precompile_workloads", true)::Bool

function precompile_mi(mi::Core.MethodInstance)
    precompile(mi)
    verbose[] && println(mi)
    return
end

include("workloads.jl")
include("invalidations.jl")

end

module PC_C

using PrecompileTools

# mimic `RecipesBase` code - see github.com/JuliaPlots/Plots.jl/issues/4597 and #317
module RB
    export @recipe

    apply_recipe(args...) = nothing
    macro recipe(ex::Expr)
        _, func_body = ex.args
        func = Expr(:call, :($RB.apply_recipe))
        Expr(
            :function,
            func,
            quote
                @nospecialize
                func_return = $func_body
            end |> esc
        )
    end
end
using .RB

@setup_workload begin
    struct Foo end
    @compile_workload begin
        @recipe f(::Foo) = nothing
    end
end

end # module PC_C

```@meta
CurrentModule = PrecompileTools
```

# Reference (API)

API documentation for [PrecompileTools](https://github.com/JuliaLang/PrecompileTools.jl).

```@index
```

```@autodocs
Modules = [PrecompileTools]
```

# Why does Julia invalidate code?

Julia may be unique among computer languages in supporting all four of the following features:

1. interactive development
2. "method overloading" by packages that don't own the function
3. aggressive compilation
4. consistent compilation: same result no matter how you got there

The combination of these features *requires* that you sometimes "throw away" code that you have previously compiled.

To illustrate: suppose you have a function `numchildren` with one method,

```
numchildren(::Any) = 1
```

and then write

```
total_children(list) = sum(numchildren.(list))
```

Now let `list` be a `Vector{Any}`. You can compile a fast `total_children(::Vector{Any})` (*aggressive compilation*) by leveraging the fact that you know there's only one possible method of `numchildren`, and you know that it returns 1
for every input. Thus, `total_children(list)` gives you just `length(list)`, which would indeed be a very highly-optimized implementation!

But now suppose you add a second method (*interactive development* + *method overloading*)

```
numchildren(::BinaryNode) = 2
```

where `BinaryNode` is a new type you've defined (so it's not type-piracy). If you want to get the right answer (*consistent compilation*) from an arbitrary `list::Vector{Any}`, there are only two options:

> **Option A**: plan for this eventuality from the beginning, by making every `numchildren(::Any)` be called by runtime dispatch. But when there is only one method of `numchildren`, forcing runtime dispatch makes the code vastly slower. Thus, this option at least partly violates *aggressive compilation*.

> **Option B**: throw away the code for `total_children` that you created when there was only one method of `numchildren`, and recompile it in this new world where there are two.

Julia does a mix of these: it does **B** up to 3 methods, and then **A** thereafter. (Recent versions of Julia have experimental support for customizing this behavior with `Base.Experimental.@max_methods`.)

This example was framed as an experiment at the REPL, but it is also relevant if you load two packages: `PkgX` might define `numchildren` and `total_children`, and `PkgY` might load `PkgX` and define a second method of `PkgX.numchildren`.
Any precompilation that occurs in `PkgX` doesn't know what's going to happen in `PkgY`.
Therefore, unless you want to defer *all* compilation, including for Julia itself, until the entire session is loaded and then closed to further extension (similar to how compilers for C, Rust, etc. work), you have to make the same choice between options **A** and **B**.

Given that invalidation is necessary if Julia code is to be both fast and deliver the answers you expect, invalidation is a good thing!
But sometimes Julia "defensively" throws out code that might be correct but can't be proved to be correct by Julia's type-inference machinery; such cases of "spurious invalidation" serve to (uselessly) increase latency and worsen the Julia experience.
Except in cases of [piracy](https://docs.julialang.org/en/v1/manual/style-guide/#Avoid-type-piracy), invalidation is a risk
only for poorly-inferred code. With our example of `numchildren` and `total_children` above, the invalidations were necessary because `list` was
a `Vector{Any}`, meaning that the elements might be of `Any` type and therefore Julia can't predict in advance which
method(s) of `numchildren` would be applicable. Were one to create `list` as, say, `list = Union{BinaryNode,TrinaryNode}[]` (where `TrinaryNode` is some other kind of object with children), Julia would know much more
about the types of the objects to which it applies `numchildren`: defining yet another new method like `numchildren(::ArbitraryNode)` would not trigger invalidations of code
that was compiled for a `list::Vector{Union{BinaryNode,TrinaryNode}}`.

# PrecompileTools

## Overview

`PrecompileTools` is designed to help reduce delay on first usage of Julia code.
It can force *precompilation* of specific workloads; particularly with Julia 1.9 and higher,
the precompiled code is automatically saved to disk, so that it doesn't need to be compiled freshly in each Julia session.
You can use `PrecompileTools` as a package developer, to reduce the latency experienced by users of your package for "typical" workloads;
you can also use `PrecompileTools` as a user, creating custom "Startup" package(s) that precompile workloads important for your work.

The main tool in `PrecompileTools` is a macro, `@compile_workload`, which precompiles all the code needed to execute the workload.
It also includes a second macro, `@setup_workload`, which can be used to "mark" a block of code as being relevant only
for precompilation but which does not itself force compilation of `@setup_workload` code. (`@setup_workload` is typically used to generate
test data using functions that you don't need to precompile in your package.)
Finally, `PrecompileTools` includes `@recompile_invalidations` to mitigate the undesirable consequences of *invalidations*.
These different tools are demonstrated below.

!!! note
    The latency reductions from PrecompileTools are maximally effective for Julia versions 1.9 and higher, and intermediate for Julia 1.8. Julia versions 1.7 and earlier may see some limited benefit as well, but have also occasionally been found to suffer from [precompilation-induced runtime performance regressions](https://github.com/JuliaLang/julia/issues/35972). If you wish, you can disable precompilation on older Julia versions by wrapping precompilation statements (see below) with `if Base.VERSION >= v"1.8" ... end`. On older Julia versions, you may wish to test packages for performance regressions when introducing precompilation directives.

## Tutorial: forcing precompilation with workloads

No matter whether you're a package developer or a user looking to make your own workloads start faster,
the basic workflow of `PrecompileTools` is the same.
Here's an illustration of how you might use `@compile_workload` and `@setup_workload`:

```julia
module MyPackage

using PrecompileTools: @setup_workload, @compile_workload    # this is a small dependency

struct MyType
    x::Int
end
struct OtherType
    str::String
end

@setup_workload begin
    # Putting some things in `@setup_workload` instead of `@compile_workload` can reduce the size of the
    # precompile file and potentially make loading faster.
    list = [OtherType("hello"), OtherType("world!")]
    @compile_workload begin
        # all calls in this block will be precompiled, regardless of whether
        # they belong to your package or not (on Julia 1.8 and higher)
        d = Dict(MyType(1) => list)
        x = get(d, MyType(2), nothing)
        last(d[MyType(1)])
    end
end

end
```

!!! warning
    `@compile_workload` should go at "top level," not compiled into a function. A pattern like `withenv(...) do @compile_workload begin ... end end`,
    where `@compile_workload` appears in the anonymous function passed to `withenv`, may defeat some of the value of PrecompileTools.

When you build `MyPackage`, it will precompile the following, *including all their callees*:

- `Pair(::MyPackage.MyType, ::Vector{MyPackage.OtherType})`
- `Dict(::Pair{MyPackage.MyType, Vector{MyPackage.OtherType}})`
- `get(::Dict{MyPackage.MyType, Vector{MyPackage.OtherType}}, ::MyPackage.MyType, ::Nothing)`
- `getindex(::Dict{MyPackage.MyType, Vector{MyPackage.OtherType}}, ::MyPackage.MyType)`
- `last(::Vector{MyPackage.OtherType})`

In this case, the "top level" calls were fully inferrable, so there are no entries on this list
that were called by runtime dispatch. Thus, here you could have gotten the same result with manual
`precompile` directives.
The key advantage of `@compile_workload` is that it works even if the functions you're calling
have runtime dispatch.

Once you set up a block using `PrecompileTools`, try your package and see if it reduces the time to first execution,
using the same workload you put inside the `@compile_workload` block.

If you're happy with the results, you're done! If you want deeper verification of whether it worked as
expected, or if you suspect problems, the [SnoopCompile package](https://github.com/timholy/SnoopCompile.jl) provides diagnostic tools.
Potential sources of trouble include invalidation (diagnosed with `SnoopCompileCore.@snoop_invalidations` and related tools)
and omission of intended calls from inside the `@compile_workload` block (diagnosed with `SnoopCompileCore.@snoop_inference` and related tools).

!!! note
    `@compile_workload` works by monitoring type-inference. If the code was already inferred
    prior to `@compile_workload` (e.g., from prior usage), you might omit any external
    methods that were called via runtime dispatch.

    You can use multiple `@compile_workload` blocks if you need to interleave `@setup_workload` code with
    code that you want precompiled.
    You can use `@snoop_inference` to check for any (re)inference when you use the code in your package.
    To fix any specific problems, you can combine `@compile_workload` with manual `precompile` directives.

## Tutorial: local "Startup" packages

Users who want to precompile workloads that have not been precompiled by the packages they use can follow the recipe
above, creating custom "Startup" packages for each project.
Imagine that you have three different kinds of analyses you do: you could have a folder

```
MyData/
  Project1/
  Project2/
  Project3/
```

From each one of those `Project` folders you could do the following:

```
(@v1.9) pkg> activate .
  Activating new project at `/tmp/Project1`

(Project1) pkg> generate Startup
  Generating  project Startup:
    Startup/Project.toml
    Startup/src/Startup.jl

(Project1) pkg> dev ./Startup
   Resolving package versions...
    Updating `/tmp/Project1/Project.toml`
  [e9c42744] + Startup v0.1.0 `Startup`
    Updating `/tmp/Project1/Manifest.toml`
  [e9c42744] + Startup v0.1.0 `Startup`

(Project1) pkg> activate Startup/
  Activating project at `/tmp/Project1/Startup`

(Startup) pkg> add PrecompileTools LotsOfPackages...
```

In the last step, you add `PrecompileTools` and all the package you'll need for your work on `Project1`
as dependencies of `Startup`.
Then edit the `Startup/src/Startup.jl` file to look similar to the tutorial previous section, e.g.,

```julia
module Startup

using LotsOfPackages...
using PrecompileTools

@compile_workload begin
    # inside here, put a "toy example" of everything you want to be fast
end

end
```

Then when you're ready to start work, from the `Project1` environment just say `using Startup`.
All the packages will be loaded, together with their precompiled code.

!!! tip
    If desired, the [Reexport package](https://github.com/simonster/Reexport.jl) can be used to ensure these packages are also exported by `Startup`.

## Tutorial: "healing" invalidations

Julia sometimes *invalidates* previously compiled code (see [Why does Julia invalidate code?](@ref)).
PrecompileTools provides a mechanism to recompile the invalidated code so that you get the full benefits
of precompilation. This capability can be used in "Startup" packages (like the one described
above), as well as by package developers.

!!! tip
    Excepting [piracy](https://docs.julialang.org/en/v1/manual/style-guide/#Avoid-type-piracy) (which is heavily discouraged),
    *type-stable (i.e., well-inferred) code cannot be invalidated.* If invalidations are a problem, an even better option
    than "healing" the invalidations is improving the inferrability of the "victim": not only will you prevent
    invalidations, you may get faster performance and slimmer binaries. Packages that can help identify
    inference problems and invalidations include [SnoopCompile](https://github.com/timholy/SnoopCompile.jl),
    [JET](https://github.com/aviatesk/JET.jl), and [Cthulhu](https://github.com/JuliaDebug/Cthulhu.jl).

The basic usage is simple: wrap expressions that might invalidate with `@recompile_invalidations`.
Invalidation can be triggered by defining new methods of external functions, including during
package loading. Using the "Startup" package above, you might wrap the `using` statements:

```julia
module Startup

using PrecompileTools
@recompile_invalidations begin
    using LotsOfPackages...
end

# Maybe a @compile_workload here?

end
```

Note that recompiling invalidations can be useful even if you don't add any additional workloads.

Alternatively, if you're a package developer worried about "collateral damage" you may cause by extending functions
owned by Base or other package (i.e., those that require `import` or module-scoping when defining the method),
you can wrap those method definitions:

```julia
module MyContainers

using AnotherPackage
using PrecompileTools

struct Container
    list::Vector{Any}
end

# This is a function created by this package, so it doesn't need to be wrapped
make_container() = Container([])

@recompile_invalidations begin
    # Only those methods extending Base or other packages need to go here
    Base.push!(obj::Container, x) = ...
    function AnotherPackage.foo(obj::Container)
        ⋮
    end
end

end
```

You can have more than one `@recompile_invalidations` block in a module. For example, you might use one to wrap your
`using`s, and a second to wrap your method extensions.

!!! warning
    Package developers should be aware of the tradeoffs in using `@recompile_invalidations` to wrap method extensions:

    - the benefit is that you might deliver a better out-of-the-box experience for your users, without them needing to customize anything
    - the downside is that it will increase the precompilation time for your package. Worse, what can be invalidated once can sometimes be invalidated again by a later package, and if that happens the time spent recompiling is wasted.

    Using `@recompile_invalidations` in a "Startup" package is, in a sense, safer because it waits for all the code to be loaded before recompiling anything. On the other hand, this requires users to implement their own customizations.

    Package developers are encouraged to try to fix "known" invalidations rather than relying reflexively on `@recompile_invalidations`.

## When you can't run a workload

There are cases where you might want to precompile code but cannot safely *execute* that code: for example, you may need to connect to a database, or perhaps this is a plotting package but you may be currently on a headless server lacking a display, etc.
In that case, your best option is to fall back on Julia's own `precompile` function.
However, as explained in [How PrecompileTools works](@ref), there are some differences between `precompile` and `@compile_workload`;
most likely, you may need multiple `precompile` directives.
Analysis with [SnoopCompile](https://github.com/timholy/SnoopCompile.jl) may be required to obtain the results you want;
in particular, combining `@snoop_inference` and `parcel` will allow you to generate a set of `precompile` directives that can be `include`d in your module definition.

Be aware that `precompile` directives are more specific to the Julia version, CPU (integer width), and OS than running a workload.

## Troubleshooting

Ensure your workload "works" (runs without error) when copy/pasted into the REPL.
If it produces an error only when placed inside `@precompile_workload`, check whether your workload runs when wrapped in a

```
let
    # workload goes here
end
```

block.

## Package developers: reducing the cost of precompilation during development

If you're frequently modifying one or more packages, you may not want to spend the extra time precompiling the full set of workloads that you've chosen to make fast for your "shipped" releases.
One can *locally* reduce the cost of precompilation for selected packages using the `Preferences.jl`-based mechanism and the `"precompile_workload"` key: from within your development environment, use

```julia
using MyPackage, Preferences
set_preferences!(MyPackage, "precompile_workload" => false; force=true)
```

This will write the following to LocalPreferences.toml alongside your active environment Project.toml

```
[MyPackage]
precompile_workload = false
```

After restarting julia, the `@compile_workload` and `@setup_workload` workloads will be disabled (locally) for `MyPackage`.
You can also specify additional packages (e.g., dependencies of `MyPackage`) if you're co-developing a suite of packages.  Simply run `set_preferences!` for the additional packages, or edit LocalPreferences.toml directly.

!!! note
    Changing `precompile_workload` will result in a one-time recompilation of all packages that depend on the package(s) from the current environment.
    Package developers may wish to set this preference locally within the "main" package's environment;
    precompilation will be skipped while you're actively developing the project, but not if you use the package
    from an external environment. This will also keep the `precompile_workload` setting independent and avoid needless recompilation
    of large environments.

Finally, it is possible to fully disable PrecompileTools.jl for all packages with

```julia
using PrecompileTools, Preferences
set_preferences!(PrecompileTools, "precompile_workloads" => false; force=true)
```

This can be helpful to reduce the system image size generated when using PackageCompiler.jl by only compiling calls made in a precompilation script.

## Seeing what got precompiled

If you want to see the list of calls that will be precompiled, navigate to the `MyPackage` folder and use

```julia
julia> using PrecompileTools

julia> PrecompileTools.verbose[] = true   # runs the block even if you're not precompiling, and print precompiled calls

julia> include("src/MyPackage.jl");
```

This will only show the direct- or runtime-dispatched method instances that got precompiled (omitting their inferrable callees).
For a more comprehensive list of all items stored in the compile_workload file, see
[PkgCacheInspector](https://github.com/timholy/PkgCacheInspector.jl).

# How PrecompileTools works

Julia itself has a function `precompile`, to which you can pass specific signatures to force precompilation.
For example, `precompile(foo, (ArgType1, ArgType2))` will precompile `foo(::ArgType1, ::ArgType2)` *and all of its inferrable callees*.
Alternatively, you can just execute some code at "top level" within the module, and during precompilation any method or signature "owned" by your package will also be precompiled.
Thus, base Julia itself has substantial facilities for precompiling code.

## The `workload` macros

`@compile_workload` adds one key feature: the *non-inferrable callees* (i.e., those called via runtime dispatch) that get
made inside the `@compile_workload` block will also be cached, *regardless of module ownership*. In essence, it's like you're adding
an explicit `precompile(noninferrable_callee, (OtherArgType1, ...))` for every runtime-dispatched call made inside `@compile_workload`.

These `workload` macros add other features as well:

- Statements that occur inside a `@compile_workload` block are executed only if the package is being actively precompiled; it does not run when the package is loaded, nor if you're running Julia with `--compiled-modules=no`.
- Compared to just running some workload at top-level, `@compile_workload` ensures that your code will be compiled (it disables the interpreter inside the block)
- PrecompileTools also defines `@setup_workload`, which you can use to create data for use inside a `@compile_workload` block. Like `@compile_workload`, this code only runs when you are precompiling the package, but it does not necessarily result in the `@setup_workload` code being stored in the package precompile file.

## `@recompile_invalidations`

`@recompile_invalidations` activates logging of invalidations before executing code in the block.
It then parses the log to extract the "leaves" of the trees of invalidations, which generally represent
the top-level calls (typically made by runtime dispatch). It then triggers their recompilation.
Note that the recompiled code may return different results than the original (this possibility is
why the code had to be invalidated in the first place).
